-module(lazy2).
-compile(export_all).
-author('hanak@emt.bme.hu, kapolnai@iit.bme.hu').
-vsn('$LastChangedDate: 2018-11-12 10:12:58 +0100 (h, 12 nov 2018) $$').
-import('lazy',[cons/1,filter/2,map/2,take/2]).
-import('sendmory',[all_different/1,check_sum/1]).
  % A használatukhoz a lazy.beam és a sendmory.beam fájlnak léteznie kell
  % az adott mappában.

-type lazy_list() :: nil | {any(), fun(() -> lazy_list())}.
% Ez a lista félig lusta: a fej mindig kiértékelődik, a farok lusta.
% A teljesen lusta lista kicsit komplikáltabb, mert nem tudni, hogy
% üres vagy sem.

-spec next_cartpow(N::integer(), L::list()) -> L1::list() | nomore.
next_cartpow(N, [N]) ->
    nomore;
next_cartpow(N, [N|T]) ->
    case next_cartpow(N, T) of
        {ok, C} -> {ok, [0|C]};
        nomore  -> nomore
    end;
next_cartpow(_N, [H|T]) ->
    {ok, [H+1|T]}.

-spec cartesian_power(integer(), lazy_list()) -> lazy_list().
cartesian_power(N, L) ->
    {L, fun () -> case next_cartpow(N, L) of
		      {ok, C} -> cartesian_power(N, C);
		      nomore  -> []
		  end
	end
    }.

-spec pitag(integer()) -> lazy_list().
% Pitagoraszi számhármasok N összegig.
pitag(N) ->
    filter(fun ([A,B,C]) ->
%                   io:format("~p~n",[{A,B,C}]),
                   A+B+C=<N andalso A=<B andalso A*B*C=/=0 andalso A*A+B*B=:=C*C
           end,
           cartesian_power(N,[2,2,3])).

-spec smm() -> lazy_list().
% SEND+MORE=MONEY: 9567+1085=10652, mo: {9,5,6,7,1,0,8,2}
smm() ->
    map(fun list_to_tuple/1,
        filter(fun (L) ->
                       %% io:format("~p~n",[L]),
                       S = hd(L), M = lists:nth(5, L),
                       S > 0 andalso M > 0 andalso
                       check_sum(list_to_tuple(L)) andalso all_different(L)
               end,
               cartesian_power(9,[0,0,0,0,0,0,5,2])) %% kis csalás, hogy hamar találjon megoldást,
               % cartesian_power(9,[0,0,0,0,0,0,0,0])) % mert így nagyon sokáig tartana
       ).

test(0) ->
    [
     take(cartesian_power(3,cons([1,2])),2),
     take(cartesian_power(3,cons([1,2])),9),
     take(pitag(30), 2),
     take(pitag(30), 30),
     take(smm(),1),
     smm(),
     vege
    ].
